import datetime

class Render(object):
    def details(self, html, stock, cash):
	html.SetPage("<title>%s</title>"
		% stock.symbol.upper())
	html.AppendToPage("<table border=1 width=100%>")
	html.AppendToPage(
		"""
		<tr>
		<td width=220>Symbol</td>
		<td width=340>
		<a href=http://finance.yahoo.com/q?s=%s>%s</a>
		</td>
		</tr>
		<tr>
		<td>Description</td>
		<td>%s</td>
		</tr>
		"""
		% (stock.symbol,
		    stock.symbol.upper(),
		    stock.description,
		    )
		)
	if stock.initial_purchase_date:
	    html.AppendToPage(
		    """
		    <tr>
		    <td>Initial Purchase Date</td>
		    <td>%s</td>
		    </tr>
		    """
		    % stock.initial_purchase_date
		    )
	if stock.buydate:
	    html.AppendToPage(
		    """
		    <tr>
		    <td>Last Buy Date</td>
		    <td>%s</td>
		    </tr>
		    """
		    % stock.buydate
		    )
	if stock.selldate:
	    html.AppendToPage(
		    """
		    <tr>
		    <td>Last Sell Date</td>
		    <td>%s</td>
		    </tr>
		    """
		    % stock.selldate
		    )
	if stock.price:
	    html.AppendToPage(
		    """
		    <tr>
		    <td>Price </td>
		    <td>$%f</td>
		    </tr>
		    """
		    % stock.price
		    )
	if stock.price_date:
	    html.AppendToPage(
		    """
		    <tr>
		    <td>Price Updated on</td>
		    <td>%s</td>
		    </tr>
		    """
		    % stock.price_date
		    )
	
	html.AppendToPage(
		"""
		<tr>
		<td>Shares</td>
		<td>%.5f</td>
		</tr>
		<tr>
		<td>Stock Value</td>
		<td>$%.2f</td>
		</tr>
		<tr>
		<td>Cash</td>
		<td>$%.2f</td>
		</tr>
		<tr>
		<td>Dividends</td>
		<td>$%.2f</td>
		</tr>
		<tr>
		<td>Capital Gain Distributions</td>
		<td>$%.2f</td>
		</tr>
		<tr>
		<td>Cash In</td>
		<td>$%.2f</td>
		</tr>
		<tr>
		<td>Cash Out</td>
		<td>$%.2f</td>
		</tr>
		"""
		% (
		    stock.shares,
		    stock.stock,
		    stock.cash,
		    stock.dividends,
		    stock.capital_gains,
		    stock.cash_in,
		    stock.cash_out,
		    )
		)

	html.AppendToPage(
		"""
		<tr>
		<td>Core Portfolio Control</td>
		<td>%f</td>
		</tr>
		<tr>
		<td>Sell Portfolio Control</td>
		<td>%f</td>
		</tr>
		<tr>
		<td>Buy Portfolio Control</td>
		<td>%f</td>
		</tr>
		"""
		% (
		    stock.portfolio_control,
		    stock.sell_portfolio_control,
		    stock.buy_portfolio_control,
		    )
		)
	html.AppendToPage(
		"""
		</table>
		"""
		)

    def recs(self, html, db, btn_ids):
	bgcolor = '#D3D3D3'
	cash = db['cash']
	total_stock = 0
	total_cash = cash.free
	html.SetPage("<title>Action List</title>")
	html.AppendToPage("<center>")
	html.AppendToPage(
		"""
		<h1>Action List</h1>
		<h3>Generated: %s</h3>
		"""
		% datetime.datetime.now().ctime()
		)
	html.AppendToPage("<table border=1 width=100%>")
	html.AppendToPage(
		"""
		<tr>
		<th><b>Symbol</b></th>
		<th width=40%><b>Description</b></th>
		<th><b>Stock</b></th>
		<th><b>Cash</b></th>
		<th><b>% Cash</b></th>
		<th><b>Action</b></th>
		<th><b>Amount</b></th>
		</tr>
		"""
		)
	html.AppendToPage(
		"""
		<tr>
		<td bgcolor='%s'>CASH</td>
		<td bgcolor='%s' colspan=2>Unallocated Cash</td>
		<td bgcolor='%s' align=right>$%.2f</td>
		<td colspan=3></td>
		</tr>
		"""
		% (
		    bgcolor,
		    bgcolor,
		    bgcolor,
		    cash.free
		    )
		)
	D = db['portfolios']
	for key in sorted(D.keys()):
	    if D[key].rec:
		bgcolor='yellow'
	    else:
		if D[key].stock > D[key].sell_portfolio_control:
		    #bgcolor = 'LightGreen'
		    bgcolor = '#90EE90'
		elif D[key].stock < D[key].buy_portfolio_control:
		    #bgcolor = 'LightCoral'
		    bgcolor = '#F08080'
	    html.AppendToPage(
		    """
		    <tr>
		    <td bgcolor=%s>
		    <wxp module="acclaim.buttons" class="Button">
		    <param name="name" value="%s">
		    <param name="label" value="%s">
		    <param name="id" value="%i">
		    </wxp></td> 
		    <td bgcolor=%s>%s</td>
		    <td bgcolor=%s align=right>$%.2f</td>
		    <td bgcolor=%s align=right>$%.2f</td>
		    <td bgcolor=%s align=right>%.2f</td>
		    """
		    % (
			bgcolor,
			D[key].symbol,
			D[key].symbol.upper(),
			btn_ids['info'][D[key].symbol],
			bgcolor, D[key].description,
			bgcolor, D[key].stock,
			bgcolor, D[key].cash,
			bgcolor, D[key].cash_level,
			)
		    )
	    if not D[key].rec:
		html.AppendToPage(
			"""
			<td></td>
			<td></td>
			</tr>
			"""
			)
	    else:
		if D[key].rec == 'BUY':
		    color = 'red'
		else:
		    color = 'green'
		html.AppendToPage(
			"""
			<td align=center bgcolor=%s>
			<wxp module="wx" class="Button">
			<param name="name" value="%s">
			<param name="label" value="%s">
			<param name="id" value="%i">
			</wxp>
			</td>
			"""
			% (bgcolor, 
			    D[key].symbol, 
			    D[key].rec, 
			    btn_ids['rec'][D[key].symbol])
			)
		html.AppendToPage(
			"""
			<td bgcolor=%s align=right>
			<font color=%s><b>$%.2f</b></font>
			</td>
			</tr>
			"""
			% ( bgcolor, color, D[key].rec_amount)
			)
	    total_stock += D[key].stock
	    total_cash += D[key].cash
	if total_cash and total_stock:
	    html.AppendToPage(
		    """
		    <tr>
		    <td colspan=2 align=center><b>%s</b></td>
		    <td align=right><b>$%.2f</b></td>
		    <td align=right><b>$%.2f</b></td>
		    <td align=right><b>%.2f</b></td>
		    <td colspan=2></td>
		    </tr>
		    """
		    % (
			"Totals",
			total_stock,
			total_cash,
			total_cash/(total_cash+total_stock)*100
			)
		    )

	html.AppendToPage("</table>")
	html.AppendToPage("</center>")
