from distribute_setup import use_setuptools
use_setuptools()
from setuptools import setup, find_packages

VER_MAJOR   = 0
VER_MINOR   = 6
VER_RELEASE = 0
#VER_FLAGS   = "-dev"
VER_FLAGS   = ""
VERSION = "%s.%s.%s%s" % (VER_MAJOR, VER_MINOR, VER_RELEASE, VER_FLAGS)

open('acclaim/__version__.py', 'w').write("""\
# This file was generated by setup.py...

VERSION_STRING  = '%(VERSION)s'
MAJOR_VERSION   = %(VER_MAJOR)s
MINOR_VERSION   = %(VER_MINOR)s
RELEASE_VERSION = %(VER_RELEASE)s

VERSION = (MAJOR_VERSION, MINOR_VERSION, RELEASE_VERSION, '%(VER_FLAGS)s')
""" % globals())

setup(
	zip_safe = False,
	setup_requires = ['setuptools_hg'],
	name='acclaim',
	version=VERSION,
	author='Glenn Johnson',
	author_email='glennpj@gmail.com',
	url='http://bitbucket.org/glennpj/acclaim/overview',
	description='Investment management program.',
	long_description="""
	ACCLAIM
	(Adjusted Core Cash Level Automatic Investment Management)
	is a program derived from Robert Lichello's AIM method.
	It attempts to be more responsive to market conditions and obtain
	a more controlled cash-to-equity ratio compared to conventional AIM.
	""",
	platforms=['Linux', 'Windows'],
	license='Apache-2.0',
	packages=find_packages(),
	include_package_data = True,
	#package_data = {'acclaim': ['help/manual.htb']},
	package_data = {
	    'acclaim': [
		'html/*.*',
		'html/_static/*.*',
		'html/_sources/*.*',
		'html/_images/*.*',
		'html/_images/math/*.*',
		'htmlhelp/*.*',
		'htmlhelp/_static/*.*',
		'htmlhelp/_images/*.*',
		'htmlhelp/_images/math/*.*',
		], 
	    },
	entry_points = {
	    'gui_scripts': [
		'acclaim = acclaim.main:main'
		]
	    },
	)
